#include"transfer.h"

MPI_Status status;
const char test_description[] = "Uni-directional MPI transfer: Blocking Send/Recv (1)";
extern int headproc;

void transfer_test_operation(void *sendbuf,void *recvbuf,int msglen,int rank,int TIMES,int proc){
  int i;
  if(proc == headproc)
    return;		

  if(rank == headproc){
    for(i = 0; i < TIMES; i ++){
      MPI_Send(sendbuf,msglen,MPI_CHAR,proc,TAG1,MPI_COMM_WORLD);
      MPI_Recv(recvbuf,msglen,MPI_CHAR,proc,TAG1,MPI_COMM_WORLD,&status);
    }
  }
  else
    if(rank == proc){
      for(i = 0; i < TIMES; i ++){
        MPI_Recv(recvbuf,msglen,MPI_CHAR,headproc,TAG1,MPI_COMM_WORLD,&status);
        MPI_Send(sendbuf,msglen,MPI_CHAR,headproc,TAG1,MPI_COMM_WORLD);
      }
    }
}
